
; CC5X Version 3.2I, Copyright (c) B Knudsen Data
; C compiler for the PICmicro family
; ************  16. Dec 2005  16:21  *************

	processor  16F676
	radix  DEC

	__config 0x318C

INDF        EQU   0x00
PCL         EQU   0x02
STATUS      EQU   0x03
FSR         EQU   0x04
PORTA       EQU   0x05
TRISA       EQU   0x85
PCLATH      EQU   0x0A
Carry       EQU   0
Zero_       EQU   2
RP0         EQU   5
GIE         EQU   7
OPTION_REG  EQU   0x81
PORTC       EQU   0x07
TMR1L       EQU   0x0E
TMR1H       EQU   0x0F
T1CON       EQU   0x10
CMCON       EQU   0x19
ADRESH      EQU   0x1E
ADCON0      EQU   0x1F
TRISC       EQU   0x87
PIE1        EQU   0x8C
OSCCAL      EQU   0x90
ANSEL       EQU   0x91
EEDAT       EQU   0x9A
EEADR       EQU   0x9B
EECON2      EQU   0x9D
ADRESL      EQU   0x9E
ADCON1      EQU   0x9F
PEIE        EQU   6
TMR1IF      EQU   0
EEIF        EQU   7
GO          EQU   1
ADIE        EQU   6
RD          EQU   0
WR          EQU   1
WREN        EQU   2
Signal      EQU   0x33
SignalOffset EQU   0x34
CurrSignal  EQU   0x35
TEMP        EQU   4
BUTTON      EQU   3
BUZZ        EQU   5
LCD_E       EQU   4
svrWREG     EQU   0x20
svrSTATUS   EQU   0x21
sv_PCLATH   EQU   0x22
i           EQU   0x23
piSignal    EQU   0x2A
arg1_3      EQU   0x2C
arg2_3      EQU   0x2E
rval_3      EQU   0x2F
rvalH       EQU   0x31
counter_3   EQU   0x32
aTs         EQU   0x2D
i_2         EQU   0x2E
aTs_2       EQU   0x27
c           EQU   0x2B
c_2         EQU   0x2B
c_3         EQU   0x26
p           EQU   0x26
i_3         EQU   0x27
lbCommand   EQU   0
c_5         EQU   0x2A
p_2         EQU   0x26
i_4         EQU   0x27
n           EQU   0x27
Point       EQU   0
i_5         EQU   0x29
Channels    EQU   0x36
Cell        EQU   0x3E
Temp        EQU   0x44
limit       EQU   0x46
Voltage     EQU   0x47
piADChannel EQU   0x29
a           EQU   0x2A
u           EQU   0x2B
i_6         EQU   0x26
C1cnt       EQU   0x29
C3cnt       EQU   0x29
C5cnt       EQU   0x29
C7cnt       EQU   0x29
p1          EQU   0x27
C9cnt       EQU   0x29
C10cnt      EQU   0x29
Vb_16       EQU   0x29
K           EQU   0x2B
liSignal    EQU   0x26
i_7         EQU   0x27
c_6         EQU   0x28
addr        EQU   0x27
data        EQU   0x28
addr_2      EQU   0x26
dat         EQU   0x27
i_8         EQU   0x26
WaitButton  EQU   0
iInertial   EQU   0x24
lbValidation EQU   1
ci          EQU   0x2C

	GOTO main

  ; FILE alipo.c
			;#define PIC16F676
			;
			;#include "BIN\16f676.h"
			;#pragma config |= 0x318C // INT OSC; 318C with Watch Dog;
			;
			;//#define Test_buzz 1
			;
			;#pragma update_RP 0

  ; FILE alipo.c
			;
			;typedef unsigned char byte;
			;typedef unsigned long int LONG;
			;typedef bit BOOL;
			;
			;//--- SIGNAL DEFINITIONS -------------------------------------------------
			;byte Signal; // current signal active (0 = Not Active);
			;byte SignalOffset; // current signal sample position;
			;byte CurrSignal; // Counter of delay for current position;
			;
			;#define TIMER_US 10000
			;
			;//--- PORT DEFINITIONS ---------------------------------------------------
			;//               76543210
			;#define  TrisA 0b00001111                
			;//               ||||||||
			;//               |||||||CELL_1         
			;//               ||||||CELL_2         
			;//               |||||CELL_3        
			;//               ||||BUTTON
			;//               |||TEMP        
			;//               ||BUZZ
			;//               |---
			;//               ---
			;
			;//               76543210
			;#define  TrisC 0b00000000
			;//               ||||||||
			;//               |||||||D4
			;//               ||||||D5
			;//               |||||D6 
			;//               ||||D7
			;//               |||E 
			;//               ||A0
			;//               |---
			;//               ---
			;
			;// LCD connector;
			;// 1   2   3   4   5   6   7   8   9   10
			;// GND U+  A0  E Contr D5  D4  D7  D6  UBL+
			;
			;#pragma  bit CELL_1   @ PORTA.0   //        - PIC-13
			;#pragma  bit CELL_2   @ PORTA.1   //        - PIC-12
			;#pragma  bit CELL_3   @ PORTA.2   //        - PIC-11
			;#pragma  bit TEMP     @ PORTA.4   //        - PIC-3 
			;#pragma  bit BUTTON   @ PORTA.3   //        - PIC-4 
			;#pragma  bit BUZZ     @ PORTA.5   //        - PIC-2 
			;#pragma  bit LCD_A0   @ PORTC.5   // LCD-4  - PIC-5 
			;#pragma  bit LCD_E    @ PORTC.4   // LCD-6  - PIC-6 
			;#pragma  bit LCD_D4   @ PORTC.0   // LCD-11 - PIC-10
			;#pragma  bit LCD_D5   @ PORTC.1   // LCD-12 - PIC-9
			;#pragma  bit LCD_D6   @ PORTC.2   // LCD-13 - PIC-8
			;#pragma  bit LCD_D7   @ PORTC.3   // LCD-14 - PIC-7
			;
			;#define TEMP_mask 0b00010000
			;
			;#define LCD_A0_mask 0b00100000
			;#define LCD_DD_mask 0b00001111
			;
			;#define BUTTON_PRESSED 0
			;//------------------------------------------------------------------------
			;
			;#define SIGNAL_VoltageLower 1
			;#define SIGNAL_VoltageUpper 2
			;#define SIGNAL_TempWarm 3
			;#define SIGNAL_TempHot 4
			;
			;#include "BIN\int16CXX.H"
			;
			;#define SET_RP0 \
			;#asm \
			;BSF   0x03,RP0 \
			;#endasm
			;
			;#define CLR_RP0 \
			;#asm \
			;BCF   0x03,RP0 \
			;#endasm
			;
			;
			;byte GetSignalByOffset();       
			;
			;#pragma origin 4
	ORG 0x0004
			;interrupt serverX( void)
			;{
serverX
			;/* W and STATUS are saved by the next macro. PCLATH is also
			;   saved if necessary. The code produced is CPU-dependent. */
			;
			;int_save_registers    // W, STATUS (and PCLATH if required)
			;; #define  int_save_registers \
			;;    char svrWREG, svrSTATUS; \
			;;    svrWREG = W; \
	MOVWF svrWREG
			;;    svrSTATUS = swap(STATUS);
	SWAPF STATUS,W
	MOVWF svrSTATUS
			;//char sv_FSR = FSR;  // save FSR if required
			;char sv_PCLATH = PCLATH; // save PCLATH
	MOVF  PCLATH,W
	MOVWF sv_PCLATH
			;
			;  // handle the interrupt (insert application code here)
			;
			;   CLR_RP0;
			;;#define CLR_RP0 \
			;;#asm \
			;;BCF   0x03,RP0 \
	BCF   0x03,RP0
			;;#endasm
			;   T1CON = 0b00000000; // Stop timer;
	CLRF  T1CON
			;
			;   if (Signal) { // Signal Active;
	MOVF  Signal,1
	BTFSC 0x03,Zero_
	GOTO  m005
			;     if (CurrSignal) { // Still waiting;
	MOVF  CurrSignal,1
	BTFSC 0x03,Zero_
	GOTO  m001
			;      CurrSignal--;
	DECF  CurrSignal,1
			;     } else {
	GOTO  m005
			;       CurrSignal = GetSignalByOffset();       
m001	CALL  GetSignalByOffset
	MOVWF CurrSignal
			;       if (!CurrSignal) { // if /x00, then loop to start;
	MOVF  CurrSignal,1
	BTFSS 0x03,Zero_
	GOTO  m002
			;         SignalOffset = 0; // return to 0;
	CLRF  SignalOffset
			;         CurrSignal = GetSignalByOffset();       
	CALL  GetSignalByOffset
	MOVWF CurrSignal
			;       }
			;       if ((SignalOffset & 1) == 0) // first position -> BUZZ sounds;
m002	BTFSC SignalOffset,0
	GOTO  m003
			;         BUZZ = 1;
	BSF   0x05,BUZZ
			;       else
	GOTO  m004
			;         BUZZ = 0;
m003	BCF   0x05,BUZZ
			;       SignalOffset++; // move forward;
m004	INCF  SignalOffset,1
			;       CurrSignal--;
	DECF  CurrSignal,1
			;     }
			;   }
			;
			;   // set timer to wait TIMER_US=10 ms;
			;   TMR1L = ((65536-TIMER_US)) & 0xFF;
m005	MOVLW .240
	MOVWF TMR1L
			;   TMR1H = ((65536-TIMER_US) >> 8) & 0xFF;
	MOVLW .216
	MOVWF TMR1H
			;   T1CON = 0b00000001; // Resume counting;
	MOVLW .1
	MOVWF T1CON
			;   TMR1IF = 0;         
	BCF   0x0C,TMR1IF
			;
			;PCLATH = sv_PCLATH;    // restore PCLATH
	MOVF  sv_PCLATH,W
	MOVWF PCLATH
			;//FSR = sv_FSR;       // restore FSR if saved
			;int_restore_registers // W, STATUS (and PCLATH if required)
			;; #define  int_restore_registers \
			;;    STATUS = swap(svrSTATUS); \
	SWAPF svrSTATUS,W
	MOVWF STATUS
			;;    svrWREG = swap(svrWREG); \
	SWAPF svrWREG,1
			;;    W = swap(svrWREG);
	SWAPF svrWREG,W
			;}
	RETFIE
			;
			;byte Signals (byte i) {
_const1
	MOVWF ci
	MOVLW .98
	SUBWF ci,W
	BTFSC 0x03,Carry
	RETLW .0
	CLRF  PCLATH
	MOVF  ci,W
	ADDWF PCL,1
	RETLW .40
	RETLW .12
	RETLW .6
	RETLW .15
	RETLW .1
	RETLW .0
	RETLW .200
	RETLW .0
	RETLW .61
	RETLW .13
	RETLW .99
	RETLW .104
	RETLW .1
	RETLW .219
	RETLW .14
	RETLW .91
	RETLW .8
	RETLW .2
	RETLW .156
	RETLW .16
	RETLW .85
	RETLW .168
	RETLW .2
	RETLW .126
	RETLW .18
	RETLW .80
	RETLW .72
	RETLW .3
	RETLW .126
	RETLW .20
	RETLW .76
	RETLW .232
	RETLW .3
	RETLW .155
	RETLW .22
	RETLW .76
	RETLW .250
	RETLW .0
	RETLW .14
	RETLW .1
	RETLW .4
	RETLW .1
	RETLW .24
	RETLW .1
	RETLW .14
	RETLW .1
	RETLW .34
	RETLW .1
	RETLW .24
	RETLW .1
	RETLW .44
	RETLW .1
	RETLW .34
	RETLW .1
	RETLW .54
	RETLW .1
	RETLW .44
	RETLW .1
	RETLW .64
	RETLW .1
	RETLW .54
	RETLW .1
	RETLW .74
	RETLW .1
	RETLW .64
	RETLW .1
	RETLW .84
	RETLW .1
	RETLW .139
	RETLW .86
	RETLW .143
	RETLW .239
	RETLW .195
	RETLW .47
	RETLW .199
	RETLW .86
	RETLW .204
	RETLW .47
	RETLW .207
	RETLW .239
	RETLW .0
	RETLW .51
	RETLW .32
	RETLW .76
	RETLW .105
	RETLW .80
	RETLW .111
	RETLW .32
	RETLW .86
	RETLW .47
	RETLW .116
	RETLW .32
	RETLW .65
	RETLW .108
	RETLW .97
	RETLW .114
	RETLW .109
	RETLW .0
Signals
	MOVWF i
			;skip(i);
	CLRF  PCLATH
	MOVF  i,W
	ADDWF PCL,1
			;#pragma return[] = 4, 7, 10, 15 	// 4, 4+3, 4+3+3, 4+3+3+5
	RETLW .4
	RETLW .7
	RETLW .10
	RETLW .15
			;#pragma return[] = 70,50,0		// SIGNAL_VoltageLower
	RETLW .70
	RETLW .50
	RETLW .0
			;#pragma return[] = 10,90,0		// SIGNAL_VoltageUpper
	RETLW .10
	RETLW .90
	RETLW .0
			;#pragma return[] = 15,10,15,90,0	// SIGNAL_TempWarm
	RETLW .15
	RETLW .10
	RETLW .15
	RETLW .90
	RETLW .0
			;#pragma return[] = 20,10,70,50,0	// SIGNAL_TempHot
	RETLW .20
	RETLW .10
	RETLW .70
	RETLW .50
	RETLW .0
			;}
			;
			;byte GetSignalByOffset() {
GetSignalByOffset
			;  W = Signals(Signal-1);
	DECF  Signal,W
	CALL  Signals
			;  return Signals (W+SignalOffset);
	ADDWF SignalOffset,W
	GOTO  Signals
			;}
			;
			;void SetSignal (byte piSignal) {
SetSignal
	MOVWF piSignal
			;  if (piSignal != Signal) {
	MOVF  piSignal,W
	XORWF Signal,W
	BTFSC 0x03,Zero_
	GOTO  m006
			;    GIE = 0;
	BCF   0x0B,GIE
			;    Signal = piSignal; 
	MOVF  piSignal,W
	MOVWF Signal
			;    BUZZ = 0;
	BCF   0x05,BUZZ
			;    SignalOffset = 0;
	CLRF  SignalOffset
			;    CurrSignal = 0;
	CLRF  CurrSignal
			;    GIE = 1;
	BSF   0x0B,GIE
			;  }
			;}
m006	RETURN

  ; FILE BIN\MATH16.H
			;// SIZE
			;
			;#pragma library 1
			;/*
			;uns16 operator* _mult8x8( uns8 arg1, uns8 arg2);
			;int16 operator* _multS8x8( int8 arg1, int8 arg2);
			;uns16 operator* _multU16x8( uns16 arg1, uns8 arg2);
			;uns16 operator* _mult16x16( uns16 arg1, uns16 arg2);
			;uns16 operator/ _divU16_8( uns16 arg1, uns8 arg2);
			;uns16 operator/ _divU16_16( uns16 arg1, uns16 arg2);
			;int16 operator/ _divS16_8( int16 arg1, int8 arg2);
			;int16 operator/ _divS16_16( int16 arg1, int16 arg2);
			;uns8 operator% _remU16_8( uns16 arg1, uns8 arg2);
			;uns16 operator% _remU16_16( uns16 arg1, uns16 arg2);
			;int8 operator% _remS16_8( int16 arg1, int8 arg2);
			;int16 operator% _remS16_16( int16 arg1, int16 arg2);
			;*/
			;
			;#if __CoreSet__ < 1600
			; #define genAdd(r,a) W=a; btsc(Carry); W=incsz(a); r+=W;
			; #define genSub(r,a) W=a; btss(Carry); W=incsz(a); r-=W;
			; #define genAddW(r,a) W=a; btsc(Carry); W=incsz(a); W=r+W;
			; #define genSubW(r,a) W=a; btss(Carry); W=incsz(a); W=r-W;
			;#else
			; #define genAdd(r,a) W=a; r=addWFC(r);
			; #define genSub(r,a) W=a; r=subWFB(r);
			; #define genAddW(r,a) W=a; W=addWFC(r);
			; #define genSubW(r,a) W=a; W=subWFB(r);
			;#endif
			;
			;
			;int8 operator*( int8 arg1, int8 arg2)  @
			;
			;uns16 operator* _mult8x8( uns8 arg1, uns8 arg2)
			;{
_mult8x8
			;    uns16 rval;
			;    char counter = sizeof(arg2)*8;
			;    rval.high8 = 0;
			;    W = arg1;
			;    do  {
			;        arg2 = rr( arg2);
			;        if (Carry)
			;            rval.high8 += W;
			;        rval = rr( rval);
			;        counter = decsz(counter);
			;    } while (1);
			;    return rval;
			;}
			;
			;
			;int16 operator* _multS8x8( int8 arg1, int8 arg2)
			;{
_multS8x8
			;    uns16 rval;
			;    char counter = sizeof(arg2)*8;
			;    int8 tmpArg2 = arg2;
			;    rval.high8 = 0;
			;    W = arg1;
			;    do  {
			;        tmpArg2 = rr( tmpArg2);
			;        if (Carry)
			;            rval.high8 += W;
			;        rval = rr( rval);
			;        counter = decsz(counter);
			;    } while (1);
			;    W = arg2;
			;    if (arg1 < 0)
			;        rval.high8 -= W;
			;    W = arg1;
			;    if (arg2 < 0)
			;        rval.high8 -= W;
			;    return rval;
			;}
			;
			;
			;uns16 operator*( uns8 arg1, uns16 arg2) exchangeArgs @
			;
			;uns16 operator* _multU16x8( uns16 arg1, uns8 arg2)
			;{
_multU16x8
	MOVWF arg2_3
			;    uns16 rval;
			;    uns8 rvalH = 0;
	CLRF  rvalH
			;    char counter = sizeof(arg1)*8;
	MOVLW .16
	MOVWF counter_3
			;    W = arg2;
	MOVF  arg2_3,W
			;    do  {
			;        arg1 = rr( arg1);
m007	RRF   arg1_3+1,1
	RRF   arg1_3,1
			;        if (Carry)
	BTFSC 0x03,Carry
			;            rvalH += W;
	ADDWF rvalH,1
			;        rvalH = rr(rvalH);
	RRF   rvalH,1
			;        rval = rr(rval);
	RRF   rval_3+1,1
	RRF   rval_3,1
			;        counter = decsz(counter);
	DECFSZ counter_3,1
			;    } while (1);
	GOTO  m007
			;    return rval;
	MOVF  rval_3,W
	RETURN
			;}
			;
			;
			;int16 operator*( int16 arg1, int16 arg2) @
			;
			;uns16 operator* _mult16x16( uns16 arg1, uns16 arg2)
			;{
_mult16x16
			;    uns16 rval;
			;    char counter = sizeof(arg1)*8;
			;    do  {
			;        Carry = 0;
			;        rval = rl( rval);
			;        arg1 = rl( arg1);
			;        if (Carry)
			;            rval += arg2;
			;        counter = decsz(counter);
			;    } while (1);
			;    return rval;
			;}
			;
			;
			;
			;uns16 operator/ _divU16_8( uns16 arg1, uns8 arg2)
			;{
_divU16_8
			;    uns8 rm = 0;
			;    char counter = sizeof(arg1)*8+1;
			;    goto ENTRY;
			;    do  {
			;        rm = rl( rm);
			;        uns8 tmp = rl( tmp);
			;        W = rm - arg2;
			;        if (tmp&1)
			;            Carry = 1;
			;        if (Carry)
			;            rm = W;
			;       ENTRY:
			;        arg1 = rl( arg1);
			;        counter = decsz(counter);
			;    } while (1);
			;    return arg1;
			;}
			;
			;
			;uns16 operator/ _divU16_16( uns16 arg1, uns16 arg2)
			;{
_divU16_16
			;    uns16 rm = 0;
			;    char counter = sizeof(arg1)*8+1;
			;    goto ENTRY;
			;    do  {
			;        rm = rl( rm);
			;        W = rm.low8 - arg2.low8;
			;        genSubW( rm.high8, arg2.high8);
			;        if (!Carry)
			;            goto ENTRY;
			;        rm.high8 = W;
			;        rm.low8 -= arg2.low8;
			;        Carry = 1;
			;       ENTRY:
			;        arg1 = rl( arg1);
			;        counter = decsz(counter);
			;    } while (1);
			;    return arg1;
			;}
			;
			;
			;int8  operator/ (int8 arg1, int8 arg2) @
			;
			;int16 operator/ _divS16_8( int16 arg1, int8 arg2)
			;{
_divS16_8
			;    uns8 rm = 0;
			;    char counter = 16+1;
			;    char sign = arg1.high8 ^ arg2.high8;
			;    if (arg1 < 0)  {
			;       INVERT:
			;        arg1 = -arg1;
			;        if (!counter)
			;            return arg1;
			;    }
			;    if (arg2 < 0)
			;        arg2 = -arg2;
			;    goto ENTRY;
			;    do  {
			;        rm = rl( rm);
			;        W = rm - arg2;
			;        if (Carry)
			;            rm = W;
			;       ENTRY:
			;        arg1 = rl( arg1);
			;        counter = decsz(counter);
			;    } while (1);
			;    if (sign & 0x80)
			;        goto INVERT;
			;    return arg1;
			;}
			;
			;
			;int16 operator/ _divS16_16( int16 arg1, int16 arg2)
			;{
_divS16_16
			;    uns16 rm = 0;
			;    char counter = sizeof(arg1)*8+1;
			;    char sign = arg1.high8 ^ arg2.high8;
			;    if (arg1 < 0)  {
			;       INVERT:
			;        arg1 = -arg1;
			;        if (!counter)
			;            return arg1;
			;    }
			;    if (arg2 < 0)
			;        arg2 = -arg2;
			;    goto ENTRY;
			;    do  {
			;        rm = rl( rm);
			;        W = rm.low8 - arg2.low8;
			;        genSubW( rm.high8, arg2.high8);
			;        if (!Carry)
			;            goto ENTRY;
			;        rm.high8 = W;
			;        rm.low8 -= arg2.low8;
			;        Carry = 1;
			;       ENTRY:
			;        arg1 = rl( arg1);
			;        counter = decsz(counter);
			;    } while (1);
			;    if (sign & 0x80)
			;        goto INVERT;
			;    return arg1;
			;}
			;
			;
			;uns8 operator% _remU16_8( uns16 arg1, uns8 arg2)
			;{
_remU16_8
			;    uns8 rm = 0;
			;    char counter = sizeof(arg1)*8;
			;    do  {
			;        arg1 = rl( arg1);
			;        rm = rl( rm);
			;        uns8 tmp = rl( tmp);
			;        W = rm - arg2;
			;        if (tmp&1)
			;            Carry = 1;
			;        if (Carry)
			;            rm = W;
			;        counter = decsz(counter);
			;    } while (1);
			;    return rm;
			;}
			;
			;
			;uns16 operator% _remU16_16( uns16 arg1, uns16 arg2)
			;{
_remU16_16
			;    uns16 rm = 0;
			;    char counter = sizeof(arg1)*8;
			;    do  {
			;        arg1 = rl( arg1);
			;        rm = rl( rm);
			;        W = rm.low8 - arg2.low8;
			;        genSubW( rm.high8, arg2.high8);
			;        if (!Carry)
			;            goto NOSUB;
			;        rm.high8 = W;
			;        rm.low8 -= arg2.low8;
			;      NOSUB:
			;        counter = decsz(counter);
			;    } while (1);
			;    return rm;
			;}
			;
			;
			;int8 operator% (int8 arg1, int8 arg2) @
			;
			;int8 operator% _remS16_8( int16 arg1, int8 arg2)
			;{
_remS16_8
			;    int8 rm = 0;
			;    char counter = 16;
			;    char sign = arg1.high8;
			;    if (arg1 < 0)
			;        arg1 = -arg1;
			;    if (arg2 < 0)
			;        arg2 = -arg2;
			;    do  {
			;        arg1 = rl( arg1);
			;        rm = rl( rm);
			;        W = rm - arg2;
			;        if (Carry)
			;            rm = W;
			;        counter = decsz(counter);
			;    } while (1);
			;    if (sign & 0x80)
			;        rm = -rm;
			;    return rm;
			;}
			;
			;
			;int16 operator% _remS16_16( int16 arg1, int16 arg2)
			;{
_remS16_16
			;    int16 rm = 0;
			;    char counter = sizeof(arg1)*8;
			;    char sign = arg1.high8;
			;    if (arg1 < 0)
			;        arg1 = -arg1;
			;    if (arg2 < 0)
			;        arg2 = -arg2;
			;    do  {
			;        arg1 = rl( arg1);
			;        rm = rl( rm);
			;        W = rm.low8 - arg2.low8;
			;        genSubW( rm.high8, arg2.high8);
			;        if (!Carry)
			;            goto NOSUB;
			;        rm.high8 = W;
			;        rm.low8 -= arg2.low8;
			;      NOSUB:
			;        counter = decsz(counter);
			;    } while (1);
			;    if (sign & 0x80)
			;        rm = -rm;
			;    return rm;

  ; FILE alipo.c
			;
			;#include "BIN\MATH16.H"
			;
			;//--- PAUSE MAKING FUNCTIONS ---------------------------------------------
			;void Delay100us (byte aTs) // pause for aTs*100 us;
			;{ // 4+x*3 us = 4+3*32=100 us;
Delay100us
	MOVWF aTs
			; do  {
			;     char i = 33;            /* 2 IS */
m008	MOVLW .33
	MOVWF i_2
			;     do ; while ( --i > 0);  /* 26 * 3 - 1 = 77 IS */
m009	DECFSZ i_2,1
	GOTO  m009
			; } while ( --aTs > 0);         /* 3 IS */
	DECFSZ aTs,1
	GOTO  m008
			;}
	RETURN
			;
			;void Delay10ms (byte aTs) // pause for aTs*10 ms;
			;{
Delay10ms
	MOVWF aTs_2
			; for (; aTs > 0; aTs--) {
m010	MOVF  aTs_2,1
	BTFSC 0x03,Zero_
	GOTO  m011
			;   Delay100us (100);
	MOVLW .100
	CALL  Delay100us
			;   clrwdt();
	CLRWDT
			; }
	DECF  aTs_2,1
	GOTO  m010
			;}
m011	RETURN
			;
			;/*
			;void DelayMs (unsigned char aTs) // pause for aTs*1 ms;
			;{
			; for (; aTs > 0; aTs--) {
			;   clrwdt();
			;   Delay100us (10);
			; }
			;}
			;*/
			;
			;//--- LCD FUNCTIONS ------------------------------------------------------
			;
			;#define LCD_DELAY_BASE_100_US 1
			;
			;void lcdWrite (char c) {
lcdWrite
	MOVWF c
			;  // high data byte;
			;  c = swap(c);
	SWAPF c,1
			;  PORTC = (c & LCD_DD_mask) | LCD_A0_mask; LCD_E = 1; nop(); LCD_E = 0;
	MOVLW .15
	ANDWF c,W
	IORLW .32
	MOVWF PORTC
	BSF   0x07,LCD_E
	NOP  
	BCF   0x07,LCD_E
			;  Delay100us (LCD_DELAY_BASE_100_US);
	MOVLW .1
	CALL  Delay100us
			;  // low data byte;
			;  c = swap(c);
	SWAPF c,1
			;  PORTC = (c & LCD_DD_mask) | LCD_A0_mask; LCD_E = 1; nop(); LCD_E = 0;
	MOVLW .15
	ANDWF c,W
	IORLW .32
	MOVWF PORTC
	BSF   0x07,LCD_E
	NOP  
	BCF   0x07,LCD_E
			;  Delay100us (LCD_DELAY_BASE_100_US);
	MOVLW .1
	GOTO  Delay100us
			;}
			;
			;void lcdCommand (char c) {
lcdCommand
	MOVWF c_2
			;  // high data byte;
			;  c = swap(c);
	SWAPF c_2,1
			;  PORTC = (c & LCD_DD_mask); LCD_E = 1; nop(); LCD_E = 0;
	MOVLW .15
	ANDWF c_2,W
	MOVWF PORTC
	BSF   0x07,LCD_E
	NOP  
	BCF   0x07,LCD_E
			;  Delay100us (LCD_DELAY_BASE_100_US);
	MOVLW .1
	CALL  Delay100us
			;  // low data byte;
			;  c = swap(c);
	SWAPF c_2,1
			;  PORTC = (c & LCD_DD_mask); LCD_E = 1; nop(); LCD_E = 0;
	MOVLW .15
	ANDWF c_2,W
	MOVWF PORTC
	BSF   0x07,LCD_E
	NOP  
	BCF   0x07,LCD_E
			;  Delay100us (LCD_DELAY_BASE_100_US);
	MOVLW .1
	GOTO  Delay100us
			;}
			;
			;void lcdCommand8 (char c) {
lcdCommand8
	MOVWF c_3
			;  PORTC = c; LCD_E = 1; nop(); LCD_E = 0;
	MOVF  c_3,W
	MOVWF PORTC
	BSF   0x07,LCD_E
	NOP  
	BCF   0x07,LCD_E
			;  Delay100us (LCD_DELAY_BASE_100_US);
	MOVLW .1
	GOTO  Delay100us
			;}
			;
			;#define LCD_CMD_POS1		( 0x80 )
			;#define LCD_CMD_POS2		(0x80 | 0x40)
			;
			;#define LCD_CURSOR_ON		lcdCommand (0xC | 0x2);
			;#define LCD_CURSOR_OFF		lcdCommand (0xC);
			;#define LCD_CURSOR_BLINK_ON	lcdCommand (0xC | 0x2 | 0x1);
			;#define LCD_CLEAR		{ lcdCommand (0x1); Delay100us (15+LCD_DELAY_BASE_100_US); }
			;#define LCD_CURSOR_HOME		lcdCommand (0x2);
			;#define LCD_SHIFT_CURSOR_LEFT	lcdCommand (0x10);
			;#define LCD_SHIFT_CURSOR_RIGHT	lcdCommand (0x10 | 0x4);
			;#define LCD_SHIFT_DISPLAY_LEFT	lcdCommand (0x10 | 0x8);
			;#define LCD_SHIFT_DISPLAY_RIGHT	lcdCommand (0x10 | 0x8 | 0x4);
			;#define LCD_CURSOR_LINE_1(x)	lcdCommand (LCD_CMD_POS1 | x);
			;#define LCD_CURSOR_LINE_2(x)	lcdCommand (LCD_CMD_POS2 | x);
			;
			;void lcdProgram (const char * p) {
lcdProgram
			;  byte i;
			;  BOOL lbCommand = 1;
	BSF   0x29,lbCommand
			;  char c;
			;  for (i = 0; ; i++) {
	CLRF  i_3
			;    char c = p[i];
m012	MOVF  i_3,W
	ADDWF p,W
	CALL  _const1
	MOVWF c_5
			;    if (c == 0)
	MOVF  c_5,1
	BTFSC 0x03,Zero_
			;      return;
	RETURN
			;    if (lbCommand) {
	BTFSS 0x29,lbCommand
	GOTO  m013
			;      lcdCommand (c);
	MOVF  c_5,W
	CALL  lcdCommand
			;      if (c & LCD_CMD_POS1) // output character after cursor placement command;
	BTFSS c_5,7
	GOTO  m014
			;        lbCommand = 0;
	BCF   0x29,lbCommand
			;    } else {
	GOTO  m014
			;      lcdWrite (c);
m013	MOVF  c_5,W
	CALL  lcdWrite
			;      lbCommand = 1;
	BSF   0x29,lbCommand
			;    }
			;  }
m014	INCF  i_3,1
	GOTO  m012
			;}
			;
			;void lcdWriteln (const char * p) {
lcdWriteln
			;  byte i;
			;  for (i = 0; p[i] != 0; i++) {
	CLRF  i_4
m015	MOVF  i_4,W
	ADDWF p_2,W
	CALL  _const1
	XORLW .0
	BTFSC 0x03,Zero_
	GOTO  m016
			;      lcdWrite(p[i]);
	MOVF  i_4,W
	ADDWF p_2,W
	CALL  _const1
	CALL  lcdWrite
			;  }
	INCF  i_4,1
	GOTO  m015
			;}
m016	RETURN
			;
			;const char LCD_Data_Init[] = {
			;  0x28, //  
			;  0x0C, //  
			;  0x6,  //     
			;  0x0F, //     
			;//  0x80, //  
			;//  ' ',
			;  0x01,  // ,  
			;  0
			;};
			;
			;void LCD_Init() { // 16s2d
LCD_Init
			;  PORTC = 0;
	CLRF  PORTC
			;  Delay10ms (5);
	MOVLW .5
	CALL  Delay10ms
			;
			;// 30h  
			;  lcdCommand8 (3);
	MOVLW .3
	CALL  lcdCommand8
			;  lcdCommand8 (3);
	MOVLW .3
	CALL  lcdCommand8
			;  lcdCommand8 (3);
	MOVLW .3
	CALL  lcdCommand8
			;
			;// 20h  
			;  lcdCommand8 (2);
	MOVLW .2
	CALL  lcdCommand8
			;
			;//4bit
			;  lcdProgram (LCD_Data_Init);
	CLRF  p
	CALL  lcdProgram
			;  Delay100us (15);
	MOVLW .15
	GOTO  Delay100us
			;}
			;
			;void WriteNum (LONG n, BOOL Point) {
WriteNum
			;  n = n+5;
	MOVLW .5
	ADDWF n,1
	BTFSC 0x03,Carry
	INCF  n+1,1
			;  byte i = '0';
	MOVLW .48
	MOVWF i_5
			;  while (n >= 100) {
m017	MOVF  n+1,W
	BTFSS 0x03,Zero_
	GOTO  m018
	MOVLW .100
	SUBWF n,W
	BTFSS 0x03,Carry
	GOTO  m019
			;    n -= 100;
m018	MOVLW .100
	SUBWF n,1
	BTFSS 0x03,Carry
	DECF  n+1,1
			;    i++;
	INCF  i_5,1
			;  }
	GOTO  m017
			;  lcdWrite (i);
m019	MOVF  i_5,W
	CALL  lcdWrite
			;  if (Point) {
	BTFSS 0x2A,Point
	GOTO  m020
			;    lcdWrite ('.');  
	MOVLW .46
	CALL  lcdWrite
			;  }
			;
			;  i = '0';
m020	MOVLW .48
	MOVWF i_5
			;  while (n >= 10) {
m021	MOVF  n+1,W
	BTFSS 0x03,Zero_
	GOTO  m022
	MOVLW .10
	SUBWF n,W
	BTFSS 0x03,Carry
	GOTO  m023
			;    n -= 10;
m022	MOVLW .10
	SUBWF n,1
	BTFSS 0x03,Carry
	DECF  n+1,1
			;    i++;
	INCF  i_5,1
			;  }
	GOTO  m021
			;  lcdWrite (i);
m023	MOVF  i_5,W
	GOTO  lcdWrite
			;}
			;
			;/*
			;void Wait () {
			; Delay10ms(50);
			; Delay10ms(50);
			;}
			;*/
			;
			;//--- ANALOG SETUP DATA --------------------------------------------------
			;#define ADChannel_Cell1 	0
			;#define ADChannel_Cell2		1
			;#define ADChannel_Cell3		2
			;#define ADChannel_Temp 		3
			;
			;LONG Channels[4];
			;LONG Cell[3];
			;LONG Temp;
			;
			;struct Limit {
			; LONG Lower;
			; LONG Upper; 
			;};
			;
			;#define DATA_LIMIT_ADDR 1
			;
			;byte limit;
			;struct Limit Voltage;
			;
			;#define TempExtCount 6
			;
			;struct TempExtData {
			;  LONG T_10;
			;  LONG V_16;
			;  byte K;
			;};
			;
			;const struct TempExtData TempExt[TempExtCount] =
			;{{200, 	3389, 	99},
			;{360, 	3803, 	91},
			;{520, 	4252, 	85},
			;{680, 	4734, 	80},
			;{840, 	5246, 	76},
			;{1000, 	5787, 	76}};
			;
			;#define VoltageCount 8
			;
			;#define DEFAULT_LIMIT 5
			;
			;const struct Limit Voltages[VoltageCount] =
			;{{250, 270}, // limit = 0, beep: -
			;{260, 280},  // limit = 1, beep: - -
			;{270, 290},  // limit = 2, beep: - - -
			;{280, 300},  // limit = 3, beep: - - - --
			;{290, 310},  // limit = 4, beep: - - - -- -
			;{300, 320},  // limit = 5, beep: - - - -- - -
			;{310, 330},  // limit = 6, beep: - - - -- - - -
			;{320, 340}}; // limit = 7, beep: - - - -- - - - --
			;
			;#define Temp_Lower 320
			;#define Temp_Upper 400
			;
			;#define NUM_VOLTAGE_SAMPLES     8  // 2, 4, 8, 16
			;
			;LONG ReadADC(byte piADChannel) {
ReadADC
	MOVWF piADChannel
			;  if (piADChannel == ADChannel_Temp) { // enable the termistor;
	MOVF  piADChannel,W
	XORLW .3
	BTFSS 0x03,Zero_
	GOTO  m024
			;    SET_RP0;
			;;#define SET_RP0 \
			;;#asm \
			;;BSF   0x03,RP0 \
	BSF   0x03,RP0
			;;#endasm
			;    ANSEL = (1 << ADChannel_Cell1) | (1 << ADChannel_Cell2) | (1 << ADChannel_Cell3) | (1 << ADChannel_Temp);
	MOVLW .15
	MOVWF ANSEL
			;    TRISA = TrisA | TEMP_mask;
	MOVLW .31
	MOVWF TRISA
			;  }
			;  CLR_RP0;
			;;#define CLR_RP0 \
			;;#asm \
			;;BCF   0x03,RP0 \
m024	BCF   0x03,RP0
			;;#endasm
			;  byte a = (piADChannel << 2);
	BCF   0x03,Carry
	RLF   piADChannel,W
	MOVWF a
	BCF   0x03,Carry
	RLF   a,1
			;  ADCON0 = (ADCON0 & 0b111.000.11) | a;
	MOVLW .227
	ANDWF ADCON0,W
	IORWF a,W
	MOVWF ADCON0
			;  Delay100us(10);
	MOVLW .10
	CALL  Delay100us
			;  GO = 1;
	BSF   0x1F,GO
			;  while (GO) { };
m025	BTFSC 0x1F,GO
	GOTO  m025
			;
			;  // disable the termistor by powering TEMP pin;
			;  SET_RP0;
			;;#define SET_RP0 \
			;;#asm \
			;;BSF   0x03,RP0 \
	BSF   0x03,RP0
			;;#endasm
			;  ANSEL = (1 << ADChannel_Cell1) | (1 << ADChannel_Cell2) | (1 << ADChannel_Cell3);
	MOVLW .7
	MOVWF ANSEL
			;  TRISA = TrisA;
	MOVLW .15
	MOVWF TRISA
			;  CLR_RP0;
			;;#define CLR_RP0 \
			;;#asm \
			;;BCF   0x03,RP0 \
	BCF   0x03,RP0
			;;#endasm
			;  TEMP = 1;
	BSF   0x05,TEMP
			;
			;  long unsigned int u;
			;  u.high8 = ADRESH;
	MOVF  ADRESH,W
	MOVWF u+1
			;  SET_RP0;
			;;#define SET_RP0 \
			;;#asm \
			;;BSF   0x03,RP0 \
	BSF   0x03,RP0
			;;#endasm
			;  u.low8 = ADRESL;
	MOVF  ADRESL,W
	MOVWF u
			;  CLR_RP0;
			;;#define CLR_RP0 \
			;;#asm \
			;;BCF   0x03,RP0 \
	BCF   0x03,RP0
			;;#endasm
			;  return u;
	MOVF  u,W
	RETURN
			;}
			;
			;void ReadChannels() {
ReadChannels
			;  Channels[0] = 0;
	CLRF  Channels
	CLRF  Channels+1
			;  Channels[1] = 0;
	CLRF  Channels+2
	CLRF  Channels+3
			;  Channels[2] = 0;
	CLRF  Channels+4
	CLRF  Channels+5
			;  Channels[3] = 0;
	CLRF  Channels+6
	CLRF  Channels+7
			;  signed int i = NUM_VOLTAGE_SAMPLES;
	MOVLW .8
	MOVWF i_6
			;  while (i > 0) {
m026	BTFSC i_6,7
	GOTO  m027
	MOVF  i_6,1
	BTFSC 0x03,Zero_
	GOTO  m027
			;    Channels[0] += ReadADC(ADChannel_Cell1);
	MOVLW .0
	CALL  ReadADC
	MOVF  u+1,W
	ADDWF Channels+1,1
	MOVF  u,W
	ADDWF Channels,1
	BTFSC 0x03,Carry
	INCF  Channels+1,1
			;    Channels[1] += ReadADC(ADChannel_Cell2);
	MOVLW .1
	CALL  ReadADC
	MOVF  u+1,W
	ADDWF Channels+3,1
	MOVF  u,W
	ADDWF Channels+2,1
	BTFSC 0x03,Carry
	INCF  Channels+3,1
			;    Channels[2] += ReadADC(ADChannel_Cell3);
	MOVLW .2
	CALL  ReadADC
	MOVF  u+1,W
	ADDWF Channels+5,1
	MOVF  u,W
	ADDWF Channels+4,1
	BTFSC 0x03,Carry
	INCF  Channels+5,1
			;    Channels[3] += ReadADC(ADChannel_Temp);
	MOVLW .3
	CALL  ReadADC
	MOVF  u+1,W
	ADDWF Channels+7,1
	MOVF  u,W
	ADDWF Channels+6,1
	BTFSC 0x03,Carry
	INCF  Channels+7,1
			;    i--;
	DECF  i_6,1
			;  }
	GOTO  m026
			;
			;  Channels[0] /= NUM_VOLTAGE_SAMPLES; // 1:1
m027	MOVLW .3
	MOVWF C1cnt
m028	BCF   0x03,Carry
	RRF   Channels+1,1
	RRF   Channels,1
	DECFSZ C1cnt,1
	GOTO  m028
			;  Channels[1] /= NUM_VOLTAGE_SAMPLES; // 1:2
	MOVLW .3
	MOVWF C3cnt
m029	BCF   0x03,Carry
	RRF   Channels+3,1
	RRF   Channels+2,1
	DECFSZ C3cnt,1
	GOTO  m029
			;  Channels[2] /= NUM_VOLTAGE_SAMPLES; // 1:3
	MOVLW .3
	MOVWF C5cnt
m030	BCF   0x03,Carry
	RRF   Channels+5,1
	RRF   Channels+4,1
	DECFSZ C5cnt,1
	GOTO  m030
			;  Channels[3] /= NUM_VOLTAGE_SAMPLES;
	MOVLW .3
	MOVWF C7cnt
m031	BCF   0x03,Carry
	RRF   Channels+7,1
	RRF   Channels+6,1
	DECFSZ C7cnt,1
	GOTO  m031
			;  // cell_1 = Channels(0) * 100 * 5 / 1023;
			;  // cell_2 = (Channels(1)*2-Channels(0)) * 100 * 5 / 1023;
			;  // cell_3 = (Channels(2)*3-Channels(1)*2) * 100 * 5 / 1023;
			;  
			;  // cell_1 = x = Channels[0]; x*(0.5-3/256) = x*(0,48828125) ~= 100 * 5 / 1023 = 0,488758553; 
			;  Cell[0] = Channels[0]/2; 	// x/2
	BCF   0x03,Carry
	RRF   Channels+1,W
	MOVWF Cell+1
	RRF   Channels,W
	MOVWF Cell
			;  LONG p1 = Channels[0]*3; 	// x*3
	MOVF  Channels,W
	MOVWF arg1_3
	MOVF  Channels+1,W
	MOVWF arg1_3+1
	MOVLW .3
	CALL  _multU16x8
	MOVF  rval_3,W
	MOVWF p1
	MOVF  rval_3+1,W
	MOVWF p1+1
			;  Cell[0] -= p1.high8;
	MOVF  p1+1,W
	SUBWF Cell,1
	BTFSS 0x03,Carry
	DECF  Cell+1,1
			;
			;  // cell_2 = x = Channels[1]; x*(1-6/256) = x*(0,9765625) ~= 100 * 5 / 1023 * 2= 0,977517107;
			;  Cell[1] = Channels[1]; 	// x
	MOVF  Channels+2,W
	MOVWF Cell+2
	MOVF  Channels+3,W
	MOVWF Cell+3
			;  p1 = Channels[1]*6; 		// x*6
	MOVF  Channels+2,W
	MOVWF arg1_3
	MOVF  Channels+3,W
	MOVWF arg1_3+1
	MOVLW .6
	CALL  _multU16x8
	MOVF  rval_3,W
	MOVWF p1
	MOVF  rval_3+1,W
	MOVWF p1+1
			;  Cell[1] -= p1.high8;        	// x-6*x/256
	MOVF  p1+1,W
	SUBWF Cell+2,1
	BTFSS 0x03,Carry
	DECF  Cell+3,1
			;
			;  // cell_3 = x = Channels[2]; x*(1,5-8,5/256)=x*(1,466796875) ~= 100*5/1023*3 = 1,46627566;
			;  Cell[2] = Channels[2]/2; 	// x/2
	BCF   0x03,Carry
	RRF   Channels+5,W
	MOVWF Cell+5
	RRF   Channels+4,W
	MOVWF Cell+4
			;  p1 = Channels[2]*8; 		// x*8
	MOVF  Channels+5,W
	MOVWF p1+1
	MOVF  Channels+4,W
	MOVWF p1
	MOVLW .3
	MOVWF C9cnt
m032	BCF   0x03,Carry
	RLF   p1,1
	RLF   p1+1,1
	DECFSZ C9cnt,1
	GOTO  m032
			;  p1+= Cell[2];                 // x * 8,5;
	MOVF  Cell+5,W
	ADDWF p1+1,1
	MOVF  Cell+4,W
	ADDWF p1,1
	BTFSC 0x03,Carry
	INCF  p1+1,1
			;  Cell[2] = Channels[2]/2;      // x/2
	BCF   0x03,Carry
	RRF   Channels+5,W
	MOVWF Cell+5
	RRF   Channels+4,W
	MOVWF Cell+4
			;  Cell[2] += Channels[2];       // 1,5*x
	MOVF  Channels+5,W
	ADDWF Cell+5,1
	MOVF  Channels+4,W
	ADDWF Cell+4,1
	BTFSC 0x03,Carry
	INCF  Cell+5,1
			;  Cell[2] -= p1.high8; 		// 1,5 * x- 8,5 * x/256
	MOVF  p1+1,W
	SUBWF Cell+4,1
	BTFSS 0x03,Carry
	DECF  Cell+5,1
			;
			;  p1 = Channels[3]*16; // V*16;
	MOVF  Channels+7,W
	MOVWF p1+1
	MOVF  Channels+6,W
	MOVWF p1
	MOVLW .4
	MOVWF C10cnt
m033	BCF   0x03,Carry
	RLF   p1,1
	RLF   p1+1,1
	DECFSZ C10cnt,1
	GOTO  m033
			;  for (i = TempExtCount-1; i >= 0; i--) {
	MOVLW .5
	MOVWF i_6
m034	BTFSC i_6,7
	GOTO  m038
			;    LONG Vb_16 = TempExt[i].V_16;
	BCF   0x03,Carry
	RLF   i_6,W
	ADDWF i_6,W
	ADDWF i_6,W
	ADDWF i_6,W
	ADDLW .8
	CALL  _const1
	MOVWF Vb_16
	INCF  ci,W
	CALL  _const1
	MOVWF Vb_16+1
			;    if ((p1 > Vb_16) || (i == 0)) {
	MOVF  p1+1,W
	SUBWF Vb_16+1,W
	BTFSS 0x03,Carry
	GOTO  m036
	BTFSS 0x03,Zero_
	GOTO  m035
	MOVF  p1,W
	SUBWF Vb_16,W
	BTFSS 0x03,Carry
	GOTO  m036
m035	MOVF  i_6,1
	BTFSS 0x03,Zero_
	GOTO  m037
			;      p1 -= Vb_16;
m036	MOVF  Vb_16+1,W
	SUBWF p1+1,1
	MOVF  Vb_16,W
	SUBWF p1,1
	BTFSS 0x03,Carry
	DECF  p1+1,1
			;      byte K = TempExt[i].K;
	BCF   0x03,Carry
	RLF   i_6,W
	ADDWF i_6,W
	ADDWF i_6,W
	ADDWF i_6,W
	ADDLW .10
	CALL  _const1
	MOVWF K
			;      p1 *= K;
	MOVF  p1,W
	MOVWF arg1_3
	MOVF  p1+1,W
	MOVWF arg1_3+1
	MOVF  K,W
	CALL  _multU16x8
	MOVF  rval_3,W
	MOVWF p1
	MOVF  rval_3+1,W
	MOVWF p1+1
			;      p1 += 128;
	MOVLW .128
	ADDWF p1,1
	BTFSC 0x03,Carry
	INCF  p1+1,1
			;      Temp = p1.high8;
	MOVF  p1+1,W
	MOVWF Temp
	CLRF  Temp+1
			;      p1 = TempExt[i].T_10;
	BCF   0x03,Carry
	RLF   i_6,W
	ADDWF i_6,W
	ADDWF i_6,W
	ADDWF i_6,W
	ADDLW .6
	CALL  _const1
	MOVWF p1
	INCF  ci,W
	CALL  _const1
	MOVWF p1+1
			;      Temp += p1;
	MOVF  p1+1,W
	ADDWF Temp+1,1
	MOVF  p1,W
	ADDWF Temp,1
	BTFSC 0x03,Carry
	INCF  Temp+1,1
			;      break;
	GOTO  m038
			;    }
			;  }  
m037	DECF  i_6,1
	GOTO  m034
			;
			;  Cell[2] -= Cell[1];
m038	MOVF  Cell+3,W
	SUBWF Cell+5,1
	MOVF  Cell+2,W
	SUBWF Cell+4,1
	BTFSS 0x03,Carry
	DECF  Cell+5,1
			;  Cell[1] -= Cell[0];
	MOVF  Cell+1,W
	SUBWF Cell+3,1
	MOVF  Cell,W
	SUBWF Cell+2,1
	BTFSS 0x03,Carry
	DECF  Cell+3,1
			;}
	RETURN
			;
			;// Find if channels Cell1, Cell2, Cell3 and Temp are available;
			;void ReadAndOutputAvailableChannels() {
ReadAndOutputAvailableChannels
			;  ReadChannels();
	CALL  ReadChannels
			;  LCD_CURSOR_LINE_1 (0);  WriteNum (Cell[0], 1);
	MOVLW .128
	CALL  lcdCommand
	MOVF  Cell,W
	MOVWF n
	MOVF  Cell+1,W
	MOVWF n+1
	BSF   0x2A,Point
	CALL  WriteNum
			;  LCD_CURSOR_LINE_1 (4);  WriteNum (Cell[1], 1);
	MOVLW .132
	CALL  lcdCommand
	MOVF  Cell+2,W
	MOVWF n
	MOVF  Cell+3,W
	MOVWF n+1
	BSF   0x2A,Point
	CALL  WriteNum
			;  LCD_CURSOR_LINE_1 (8);  WriteNum (Cell[2], 1);
	MOVLW .136
	CALL  lcdCommand
	MOVF  Cell+4,W
	MOVWF n
	MOVF  Cell+5,W
	MOVWF n+1
	BSF   0x2A,Point
	CALL  WriteNum
			;  LCD_CURSOR_LINE_1 (13); WriteNum (Temp, 0);
	MOVLW .141
	CALL  lcdCommand
	MOVF  Temp,W
	MOVWF n
	MOVF  Temp+1,W
	MOVWF n+1
	BCF   0x2A,Point
	GOTO  WriteNum
			;}
			;
			;void CheckAndSignal() {
CheckAndSignal
			;  if (Temp >= Temp_Upper) {
	MOVLW .1
	SUBWF Temp+1,W
	BTFSS 0x03,Carry
	GOTO  m040
	BTFSS 0x03,Zero_
	GOTO  m039
	MOVLW .144
	SUBWF Temp,W
	BTFSS 0x03,Carry
	GOTO  m040
			;    SetSignal (SIGNAL_TempHot);
m039	MOVLW .4
	GOTO  SetSignal
			;    return;
			;  }
			;  
			;  byte liSignal = 0;
m040	CLRF  liSignal
			;  byte i;
			;  for (i=0; i<3; i++) {
	CLRF  i_7
m041	MOVLW .3
	SUBWF i_7,W
	BTFSC 0x03,Carry
	GOTO  m046
			;    LONG c = Cell[i];
	BCF   0x03,Carry
	RLF   i_7,W
	ADDLW .62
	MOVWF FSR
	MOVF  INDF,W
	MOVWF c_6
	INCF  FSR,1
	MOVF  INDF,W
	MOVWF c_6+1
			;    if (c <= Voltage.Lower) {
	MOVF  c_6+1,W
	SUBWF Voltage+1,W
	BTFSS 0x03,Carry
	GOTO  m043
	BTFSS 0x03,Zero_
	GOTO  m042
	MOVF  c_6,W
	SUBWF Voltage,W
	BTFSS 0x03,Carry
	GOTO  m043
			;      SetSignal (SIGNAL_VoltageLower);
m042	MOVLW .1
	GOTO  SetSignal
			;      return;
			;    }
			;    if (c <= Voltage.Upper) {
m043	MOVF  c_6+1,W
	SUBWF Voltage+3,W
	BTFSS 0x03,Carry
	GOTO  m045
	BTFSS 0x03,Zero_
	GOTO  m044
	MOVF  c_6,W
	SUBWF Voltage+2,W
	BTFSS 0x03,Carry
	GOTO  m045
			;      liSignal = SIGNAL_VoltageUpper;
m044	MOVLW .2
	MOVWF liSignal
			;    }
			;  }
m045	INCF  i_7,1
	GOTO  m041
			;  if (Temp >= Temp_Lower) {
m046	MOVLW .1
	SUBWF Temp+1,W
	BTFSS 0x03,Carry
	GOTO  m048
	BTFSS 0x03,Zero_
	GOTO  m047
	MOVLW .64
	SUBWF Temp,W
	BTFSS 0x03,Carry
	GOTO  m048
			;    liSignal = SIGNAL_TempWarm;
m047	MOVLW .3
	MOVWF liSignal
			;  } 
			;  SetSignal (liSignal);
m048	MOVF  liSignal,W
	GOTO  SetSignal
			;}
			;
			;/********************************* EEPROM Read and Write *******************************************/
			;
			;#define DATA_VALID 200
			;#define DATA_VALID_ADDR 0
			;
			;// Write data to the EEPROM
			;// Beware - it takes about 4 mS for the write to complete
			;void EEPROM_Write(char addr, char data) {
EEPROM_Write
	MOVWF data
			;	EEIF = 0;					// clear done flag
	BCF   0x0C,EEIF
			;        SET_RP0;
			;;#define SET_RP0 \
			;;#asm \
			;;BSF   0x03,RP0 \
	BSF   0x03,RP0
			;;#endasm
			;	EEADR = addr;					// set up address
	MOVF  addr,W
	MOVWF EEADR
			;#if defined PIC16F676
			;	EEDAT = data;					// set up data to write
	MOVF  data,W
	MOVWF EEDAT
			;#else
			;	EEDATA = data;					// set up data to write
			;#endif
			;	WREN = 1;					// enable writing
	BSF   0x9C,WREN
			;	EECON2 = 0x55;					// required sequence
	MOVLW .85
	MOVWF EECON2
			;	EECON2 = 0xAA;
	MOVLW .170
	MOVWF EECON2
			;	WR = 1;						// do the write
	BSF   0x9C,WR
			;	WREN = 0;					// disable other writes
	BCF   0x9C,WREN
			;        CLR_RP0;
			;;#define CLR_RP0 \
			;;#asm \
			;;BCF   0x03,RP0 \
	BCF   0x03,RP0
			;;#endasm
			;	while (EEIF == 0) {};				// wait for write to complete - about 4mS
m049	BTFSS 0x0C,EEIF
	GOTO  m049
			;	EEIF = 0;					// clear done flag
	BCF   0x0C,EEIF
			;}
	RETURN
			;
			;char EEPROM_Read(char addr) {
EEPROM_Read
	MOVWF addr_2
			;	char dat;
			;        SET_RP0;
			;;#define SET_RP0 \
			;;#asm \
			;;BSF   0x03,RP0 \
	BSF   0x03,RP0
			;;#endasm
			;	EEADR = addr;
	MOVF  addr_2,W
	MOVWF EEADR
			;	RD = 1;						// do the read
	BSF   0x9C,RD
			;#if defined PIC16F676
			;	dat = EEDAT;
	MOVF  EEDAT,W
	MOVWF dat
			;#else
			;	dat = EEDATA;
			;#endif
			;        CLR_RP0;
			;;#define CLR_RP0 \
			;;#asm \
			;;BCF   0x03,RP0 \
	BCF   0x03,RP0
			;;#endasm
			;	return dat;					// result immediately available
	MOVF  dat,W
	RETURN
			;}
			;
			;#ifdef Test_buzz
			;byte iSignal;
			;#endif
			;
			;void SetLimit() {
SetLimit
			; Voltage.Lower = Voltages[limit].Lower;
	BCF   0x03,Carry
	RLF   limit,W
	ADDWF limit,W
	ADDWF limit,W
	ADDLW .36
	CALL  _const1
	MOVWF Voltage
	INCF  ci,W
	CALL  _const1
	MOVWF Voltage+1
			; Voltage.Upper = Voltages[limit].Upper;
	BCF   0x03,Carry
	RLF   limit,W
	ADDWF limit,W
	ADDWF limit,W
	ADDLW .38
	CALL  _const1
	MOVWF Voltage+2
	INCF  ci,W
	CALL  _const1
	MOVWF Voltage+3
			; EEPROM_Write (DATA_LIMIT_ADDR, limit);
	MOVLW .1
	MOVWF addr
	MOVF  limit,W
	CALL  EEPROM_Write
			;
			; LCD_CURSOR_LINE_2 (0);  WriteNum (Voltage.Lower, 1);
	MOVLW .192
	CALL  lcdCommand
	MOVF  Voltage,W
	MOVWF n
	MOVF  Voltage+1,W
	MOVWF n+1
	BSF   0x2A,Point
	CALL  WriteNum
			; LCD_CURSOR_LINE_2 (4);  WriteNum (Voltage.Upper, 1);
	MOVLW .196
	CALL  lcdCommand
	MOVF  Voltage+2,W
	MOVWF n
	MOVF  Voltage+3,W
	MOVWF n+1
	BSF   0x2A,Point
	CALL  WriteNum
			; LCD_CURSOR_LINE_2 (10); WriteNum (Temp_Lower, 0);
	MOVLW .202
	CALL  lcdCommand
	MOVLW .64
	MOVWF n
	MOVLW .1
	MOVWF n+1
	BCF   0x2A,Point
	CALL  WriteNum
			; LCD_CURSOR_LINE_2 (13); WriteNum (Temp_Upper, 0);
	MOVLW .205
	CALL  lcdCommand
	MOVLW .144
	MOVWF n
	MOVLW .1
	MOVWF n+1
	BCF   0x2A,Point
	CALL  WriteNum
			;
			; BUZZ = 0;
	BCF   0x05,BUZZ
			; if (Signal)
	MOVF  Signal,1
	BTFSC 0x03,Zero_
	GOTO  m050
			;   Delay10ms (50);
	MOVLW .50
	CALL  Delay10ms
			;
			; int i = 1;
m050	MOVLW .1
	MOVWF i_8
			; while (i <= limit+1) {
m051	INCF  limit,W
	SUBWF i_8,W
	BTFSS 0x03,Carry
	GOTO  m052
	BTFSS 0x03,Zero_
	GOTO  m054
			;   BUZZ = 1;
m052	BSF   0x05,BUZZ
			;   Delay10ms (20);
	MOVLW .20
	CALL  Delay10ms
			;   if ((i & 3) == 0)
	MOVLW .3
	ANDWF i_8,W
	BTFSS 0x03,Zero_
	GOTO  m053
			;     Delay10ms (20);
	MOVLW .20
	CALL  Delay10ms
			;   BUZZ = 0;
m053	BCF   0x05,BUZZ
			;   Delay10ms (20);
	MOVLW .20
	CALL  Delay10ms
			;   i++;
	INCF  i_8,1
			; }
	GOTO  m051
			; if (Signal)
m054	MOVF  Signal,1
	BTFSC 0x03,Zero_
	GOTO  m055
			;   Delay10ms (30);
	MOVLW .30
	GOTO  Delay10ms
			;
			;#ifdef Test_buzz
			; if (iSignal == 0)
			;   SetSignal (0);
			; else 
			; if (iSignal == 1)
			;   SetSignal (SIGNAL_VoltageLower);
			; else 
			; if (iSignal == 2)
			;   SetSignal (SIGNAL_VoltageUpper);
			; else 
			; if (iSignal == 3)
			;   SetSignal (SIGNAL_TempWarm);
			; else 
			;   SetSignal (SIGNAL_TempHot);
			; LCD_CURSOR_LINE_1 (12);  lcdWrite ('0'+Signal);
			;
			; iSignal++;
			; if (iSignal > 4) 
			;   iSignal = 0;
			;#endif
			;}
m055	RETURN
			;
			;void Press() {
Press
			; limit++;
	INCF  limit,1
			; if (limit >= VoltageCount) {
	MOVLW .8
	SUBWF limit,W
	BTFSS 0x03,Carry
	GOTO  SetLimit
			;   limit = 0;
	CLRF  limit
			; } 
			; SetLimit();
	GOTO  SetLimit
			;}
			;
			;#define LCD_CH_ALARM		0xED
			;#define LCD_CH_TEMPERATURE	0xEF
			;#define LCD_CH_ACCURE_DATA      0xED
			;
			;const char LCD_Data_Fill[] = {
			;  LCD_CMD_POS1 | 11, 'V',
			;  LCD_CMD_POS1 | 15, LCD_CH_TEMPERATURE,
			;
			;  LCD_CMD_POS2 | 3,  '/',
			;  LCD_CMD_POS2 | 7,  'V',
			;  LCD_CMD_POS2 | 12, '/',
			;  LCD_CMD_POS2 | 15, LCD_CH_TEMPERATURE,
			;  0
			;};
			;
			;char GetOsccal();							// Defined at end of file
			;
			;void main() {
main
			;  W = GetOsccal();						// Set built-in oscillator calibration
	CALL  GetOsccal
			;  SET_RP0;
			;;#define SET_RP0 \
			;;#asm \
			;;BSF   0x03,RP0 \
	BSF   0x03,RP0
			;;#endasm
			;  OSCCAL = W;
	MOVWF OSCCAL
			;  
			;  TRISA = TrisA;
	MOVLW .15
	MOVWF TRISA
			;  TRISC = TrisC;
	CLRF  TRISC
			;  OPTION = 0b11001110; // no pull-up, int/b0 on 0->1; Prescalder 64 -> ~1 sec. to WDT;
	MOVLW .206
	MOVWF OPTION_REG
			;  CLR_RP0;
			;;#define CLR_RP0 \
			;;#asm \
			;;BCF   0x03,RP0 \
	BCF   0x03,RP0
			;;#endasm
			;  PORTA = 0; 
	CLRF  PORTA
			;  TEMP = 1; // disable termistor with connecting its both pins to the 1. 5 ma current will flow through the TEMP pin.
	BSF   0x05,TEMP
			;  PORTC = 0; 
	CLRF  PORTC
			;
			;  CMCON = 0b.0000.0111; // comparator is turned off;
	MOVLW .7
	MOVWF CMCON
			;
			;  SET_RP0;
			;;#define SET_RP0 \
			;;#asm \
			;;BSF   0x03,RP0 \
	BSF   0x03,RP0
			;;#endasm
			;  ANSEL = (1 << ADChannel_Cell1) | (1 << ADChannel_Cell2) | (1 << ADChannel_Cell3);
	MOVLW .7
	MOVWF ANSEL
			;
			;  ADCON1 = 0b0.101.0000;      //  Select the Clock as Fosc/16
	MOVLW .80
	MOVWF ADCON1
			;
			;  ADIE = 0;
	BCF   0x8C,ADIE
			;
			;  CLR_RP0;
			;;#define CLR_RP0 \
			;;#asm \
			;;BCF   0x03,RP0 \
	BCF   0x03,RP0
			;;#endasm
			;  ADCON0 = 0b10.0.000.01;     //  Turn on the ADC
	MOVLW .129
	MOVWF ADCON0
			;                              //   Bit 7 - Right Justified Sample
			;                              //   Bit 6 - Dont Use VRef
			;                              //   Bit 4:2 - Channel 0
			;                              //   Bit 1 - Do not Start
			;                              //   Bit 0 - Turn on ADC
			;
			;  Signal = 0; // Not Active;
	CLRF  Signal
			;#ifdef Test_buzz
			;  iSignal = 0;
			;#endif
			;
			;  LCD_Init();          
	CALL  LCD_Init
			;//  LCD_CURSOR_LINE_1 (0);
			;//  lcdWriteln ("3 LiPo V/t");
			;  lcdWriteln ("3 LiPo V/t Alarm");
	MOVLW .81
	MOVWF p_2
	CALL  lcdWriteln
			;//  LCD_CURSOR_LINE_2 (0);
			;//  lcdWriteln ("(c) Prikupets A.");
			;  Delay10ms (100);
	MOVLW .100
	CALL  Delay10ms
			;  LCD_CLEAR;
	MOVLW .1
	CALL  lcdCommand
	MOVLW .16
	CALL  Delay100us
			;
			;  lcdProgram (LCD_Data_Fill);
	MOVLW .68
	MOVWF p
	CALL  lcdProgram
			;  ReadAndOutputAvailableChannels();
	CALL  ReadAndOutputAvailableChannels
			;
			;  if (EEPROM_Read(DATA_VALID_ADDR) != DATA_VALID) {
	MOVLW .0
	CALL  EEPROM_Read
	XORLW .200
	BTFSC 0x03,Zero_
	GOTO  m056
			;    limit = DEFAULT_LIMIT;
	MOVLW .5
	MOVWF limit
			;    EEPROM_Write (DATA_VALID_ADDR, DATA_VALID);
	CLRF  addr
	MOVLW .200
	CALL  EEPROM_Write
			;  } else {
	GOTO  m057
			;    limit = EEPROM_Read(DATA_LIMIT_ADDR);
m056	MOVLW .1
	CALL  EEPROM_Read
	MOVWF limit
			;  }
			;  SetLimit();
m057	CALL  SetLimit
			;
			;  // Init Timer1;
			;  TMR1L = ((65536-TIMER_US)) & 0xFF;
	MOVLW .240
	MOVWF TMR1L
			;  TMR1H = ((65536-TIMER_US) >> 8) & 0xFF;
	MOVLW .216
	MOVWF TMR1H
			;  T1CON = 0b00000001; // Resume counting;
	MOVLW .1
	MOVWF T1CON
			;  TMR1IF = 0;           
	BCF   0x0C,TMR1IF
			;
			;  SET_RP0;
			;;#define SET_RP0 \
			;;#asm \
			;;BSF   0x03,RP0 \
	BSF   0x03,RP0
			;;#endasm
			;  PIE1 = 1; 
	MOVLW .1
	MOVWF PIE1
			;
			;  PEIE = 1;
	BSF   0x0B,PEIE
			;  GIE = 1;
	BSF   0x0B,GIE
			;
			;  CLR_RP0;
			;;#define CLR_RP0 \
			;;#asm \
			;;BCF   0x03,RP0 \
	BCF   0x03,RP0
			;;#endasm
			;  BOOL WaitButton = (BUTTON==BUTTON_PRESSED);
	BSF   0x25,WaitButton
	BTFSC 0x05,BUTTON
	BCF   0x25,WaitButton
			;  byte iInertial = 0;
	CLRF  iInertial
			;  BOOL lbValidation = 0;
	BCF   0x25,lbValidation
			;  while (1) {
			;    clrwdt(); 
m058	CLRWDT
			;    ReadAndOutputAvailableChannels();
	CALL  ReadAndOutputAvailableChannels
			;
			;#define VALIDATION_COUNT 25
			;
			;    lcdCommand (LCD_CMD_POS2 | 9);
	MOVLW .201
	CALL  lcdCommand
			;    if (iInertial == VALIDATION_COUNT) { // Validation each ~ 1s;
	MOVF  iInertial,W
	XORLW .25
	BTFSS 0x03,Zero_
	GOTO  m059
			;      CheckAndSignal();
	CALL  CheckAndSignal
			;      lcdWrite (LCD_CH_ACCURE_DATA);
	MOVLW .237
	CALL  lcdWrite
			;      iInertial = 0;
	CLRF  iInertial
			;    } else 
	GOTO  m060
			;    if (iInertial > VALIDATION_COUNT/4) {
m059	MOVLW .7
	SUBWF iInertial,W
	BTFSS 0x03,Carry
	GOTO  m060
			;      lcdWrite (' ');
	MOVLW .32
	CALL  lcdWrite
			;    }
			;    iInertial++;
m060	INCF  iInertial,1
			;
			;    if (WaitButton) {
	BTFSS 0x25,WaitButton
	GOTO  m061
			;      lcdCommand (LCD_CMD_POS2 | 7);
	MOVLW .199
	CALL  lcdCommand
			;      LCD_CURSOR_BLINK_ON;
	MOVLW .15
	CALL  lcdCommand
			;    } else {
	GOTO  m062
			;      LCD_CURSOR_OFF;
m061	MOVLW .12
	CALL  lcdCommand
			;    }
			;
			;    if ((BUTTON==BUTTON_PRESSED) && !WaitButton) {
m062	BTFSC 0x05,BUTTON
	GOTO  m063
	BTFSC 0x25,WaitButton
	GOTO  m063
			;      Delay10ms(2);
	MOVLW .2
	CALL  Delay10ms
			;      if (BUTTON==BUTTON_PRESSED) {
	BTFSC 0x05,BUTTON
	GOTO  m058
			;        Press();
	CALL  Press
			;        WaitButton = 1;
	BSF   0x25,WaitButton
			;      }
			;    } else
	GOTO  m058
			;    if ((BUTTON != BUTTON_PRESSED) && WaitButton) {
m063	BTFSS 0x05,BUTTON
	GOTO  m058
	BTFSS 0x25,WaitButton
	GOTO  m058
			;      Delay10ms(2);
	MOVLW .2
	CALL  Delay10ms
			;      if (BUTTON != BUTTON_PRESSED) {
	BTFSS 0x05,BUTTON
	GOTO  m058
			;        WaitButton = 0;
	BCF   0x25,WaitButton
			;      }
			;    }
			;  };
	GOTO  m058
			;}
			;
			;#pragma origin 0x3FF
	ORG 0x03FF
			;// This is a dummy - actual procedure is preset in chip and will override
			;// A change of 1 causes about 1% change in frequency
			;char GetOsccal() {return 0x0;}
GetOsccal
	RETLW .0

	END


; *** KEY INFO ***

; 0x00B2    4 word(s)  0 % : GetSignalByOffset
; 0x0004   44 word(s)  4 % : serverX
; 0x009A   24 word(s)  2 % : Signals
; 0x00B6   13 word(s)  1 % : SetSignal
; 0x00C3   16 word(s)  1 % : _multU16x8
; 0x00D3    8 word(s)  0 % : Delay100us
; 0x00DB   10 word(s)  0 % : Delay10ms
; 0x00E5   21 word(s)  2 % : lcdWrite
; 0x00FA   19 word(s)  1 % : lcdCommand
; 0x010D    8 word(s)  0 % : lcdCommand8
; 0x0115   22 word(s)  2 % : lcdProgram
; 0x0030  106 word(s) 10 % : _const1
; 0x012B   14 word(s)  1 % : lcdWriteln
; 0x0139   15 word(s)  1 % : LCD_Init
; 0x0148   42 word(s)  4 % : WriteNum
; 0x0172   40 word(s)  3 % : ReadADC
; 0x019A  254 word(s) 24 % : ReadChannels
; 0x0298   33 word(s)  3 % : ReadAndOutputAvailableChannels
; 0x02B9   67 word(s)  6 % : CheckAndSignal
; 0x02FC   19 word(s)  1 % : EEPROM_Write
; 0x030F   10 word(s)  0 % : EEPROM_Read
; 0x0319   90 word(s)  8 % : SetLimit
; 0x0373    7 word(s)  0 % : Press
; 0x03FF    1 word(s)  0 % : GetOsccal
; 0x037A  121 word(s) 11 % : main

; RAM usage: 43 bytes (19 local), 21 bytes free
; Maximum call level: 4 (+3 for interrupt)
; Total of 1009 code words (98 %)
